/* string.c     delete extra blanks, delete trailing blanks */

#include <na.h>

BYTE dtb_xeol[] = {
1,1,1,1,1,1,1,1,1,0,2,1,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0};

#define DTB_FX(X)    ((X<33) ? dtb_xeol[X] : 1)

fx_dltb(dst, src)       /* delete trailing blanks */
MATRIX  dst;
MATRIX  src;
{
BYTE   *s  = src->ADDR;
int     n  = MSIZE(s);
int     nc = MCOLS(s);
int     j, k, qq;
BYTE   *t;
 
if (n != nc ) return sasa(dst, src);
for (s =TEXT_PTR(src) + n-1, qq = 0, j = n; 0 < j--;  s--) {
    k = *s;
    k = 3 * qq + DTB_FX(k);
    if (k == 0) *s = 0;         /* delete */
    else if (k == 1) qq = 1;    /* don't delete any more */
    else if (k == 5) qq = 0;    /* can start again */
    }
 
for (s = TEXT_PTR(src), k = 0, j = n; 0 < j--; s++)
    if (*s) k++;        /* count number to extract */
 
if (mkobj(dst, 'T', k, k)) return ERROR;

for (t = TEXT_PTR(dst), s =TEXT_PTR(src), j = n; 0 < j--;  s++)
    if (*s) *t++ = *s;  /* copy non-blank */
return OK;
}

fx_deb(dst, src)        /* delete extra blanks */
MATRIX  dst;            /* separate words by just one blank */
MATRIX  src;
{
BYTE   *s  = src->ADDR;
int     n  = MSIZE(s);
int     nc = MCOLS(s);
int     j, k, qq, qxb;
BYTE   *t;
 
if (n != nc ) return sasa(dst, src);
for (s = TEXT_PTR(src), qq = qxb = 0, j = n; 0 < j--;  s++) {
    k = *s;
    k = DTB_FX(k);
    switch (3 * qq + k) {
    case 6:                     /* EB */
    case 0:  *s = 0;            /* BB */
        break;
    case 2:  if (qxb) *t = 0;   /* BE */
             qxb = 0;
        break;
    case 3:  t  = s;            /* XB */
             qxb = 1;
        break;
    default: qxb = 0;           /* ?X */
        break;
        }
    qq = k;
    }

if (qxb) *t = 0;               /* last time */
 
for (s = TEXT_PTR(src), k = 0, j = n; 0 < j--; s++)
    if (*s) k++;        /* count number to extract */

if (mkobj(dst, 'T', k, k)) return ERROR;

for (t = TEXT_PTR(dst), s =TEXT_PTR(src), j = n; 0 < j--;  s++)
    if (*s) *t++ = *s;  /* copy non-blank */
return OK;
}




